#include "grafo-ma.h"


/* Crea un grafo *pG di n nodi senza archi */
void creagrafo (int n, grafo *pG)
{
  int o;

  pG->n = n;
  pG->m = 0;
  pG->MatriceAdiacenza = (boolean **) calloc(pG->n+1,sizeof(boolean *));
  if (pG->MatriceAdiacenza == NULL)
  {
    fprintf(stderr,"Errore nell'allocazione della matrice di adiacenza!\n");
    exit(EXIT_FAILURE);
  }
  for (o = 1; o <= pG->n; o++)
  {
    pG->MatriceAdiacenza[o] = (boolean *) calloc(pG->n+1,sizeof(boolean));
    if (pG->MatriceAdiacenza[o] == NULL)
    {
      fprintf(stderr,"Errore nell'allocazione della riga %d della matrice di adiacenza!\n",o);
      exit(EXIT_FAILURE);
    }
  }
}


/* Distrugge il grafo *pG */
void distruggegrafo (grafo *pG)
{
  int o;


  for (o = 1; o <= pG->n; o++)
    free(pG->MatriceAdiacenza[o]);
  free(pG->MatriceAdiacenza);
  pG->MatriceAdiacenza = NULL;

  pG->m = 0;
  pG->n = 0;
}


/* Aggiunge l'arco (o,d) al grafo G
   N.B.: non verifica che l'arco sia nuovo! */
void insarco (nodo orig, nodo dest, grafo *pG)
{
  pG->m++;
  pG->MatriceAdiacenza[orig][dest] = TRUE;
}


/* Cancella l'arco (o,d) dal grafo G
   N.B.: non verifica che l'arco sia presente! */
void cancarco (nodo orig, nodo dest, grafo *pG)
{
  pG->m--;
  pG->MatriceAdiacenza[orig][dest] = FALSE;
}


/* Determina se l'arco (orig,dest) appartiene al grafo *pG */
boolean esistearco (nodo orig, nodo dest, grafo *pG)
{
  return pG->MatriceAdiacenza[orig][dest];
}


/* Stampa a video il grafo G */
void stampagrafo (grafo *pG)
{
  int o, d;


  for (o = 1; o <= pG->n; o++)
    for (d = 1; d <= pG->n; d++)
      if (pG->MatriceAdiacenza[o][d]) printf("(%d,%d) ",o,d);
}
